#include <stdio.h>
#include <string.h>

#define NMAX 64

unsigned long long C[NMAX][NMAX];

void ComputeComb() {
	int i, j;
	memset(C, 0, sizeof(C));
	C[0][0] = 1;
	for (i = 1; i < NMAX; i++) {
		C[i][0] = 1;
		for (j = 1; j < NMAX; j++)
			C[i][j] = C[i - 1][j - 1] + C[i - 1][j];
	}
}

unsigned long long prime[21] = {
1, 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71
};

#define VMAX 9223372036854775807ULL

unsigned long long N, ans, tmp, M;
int e[21];
int sum, j, k;

void FindAnswer(int idx) {
	if (idx > 20)
		return;

	//fprintf(stderr, "idx=%d sum=%d M=%llu\n", idx, sum, M);

	for (e[idx] = e[idx - 1]; e[idx] >= 1; e[idx]--) {
		sum += e[idx];
		if (sum < NMAX && (M % C[sum][e[idx]] == 0)) {
			M /= C[sum][e[idx]];
			//fprintf(stderr, "  idx=%d sum=%d M=%llu\n", idx, sum, M);

			if (M == 1) {
				tmp = 1;
				
				for (j = 1; j <= idx; j++) {
					for (k = 1; k <= e[j]; k++)
						if (tmp > VMAX / prime[j])
							break;
						else
							tmp *= prime[j];
					if (k <= e[j])
						break;
				}

				if (j > idx && tmp > 1) {
					if (ans == 0 || tmp < ans)
						ans = tmp;
				}
			} else
				FindAnswer(idx + 1);
			M *= C[sum][e[idx]];
		}
		sum -= e[idx];
	}
}

int main() {
	ComputeComb();

	while (scanf("%llu", &N) == 1) {
		ans = 0;
		sum = 0;
		M = N;
		e[0] = 63;
		FindAnswer(1);
		printf("%llu %llu\n", N, ans);
	}

	return 0;
}
