#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 511
#define INF 1000000000

vector<pair<int, int> > vv;
vector<int> v2;
int C[NMAX][NMAX], G[NMAX][NMAX], v[NMAX];
int N, i, j, k, l, p, tmp;

void OptGroup() {
	for (i = 1; i <= N; i++)
		G[i][i] = 0;

	for (l = 2; l <= N; l++)
		for (i = 1; i <= N - l + 1; i++) {
			j = i + l - 1;
			G[i][j] = INF;

			vv.clear();
			for (k = i; k <= j; k++)
				vv.push_back(make_pair(v[k], k));
	
			sort(vv.begin(), vv.end());
			for (k = 1; k < l; k++)
				if (vv[k].first == vv[k - 1].first)
					break;
	
			if (k < l)
				continue;
			
			for (k = vv[0].second, p = 0; k < j; k++) {
				while (p + 1 < l && vv[p + 1].second <= k)
					p++;
				tmp = G[i][k] + G[k + 1][j] + l - (p + 1);
				//fprintf(stderr, "  a-split %d-%d: k=%d p+1=%d (%d,%d): tmp=%d\n", i, j, k, p + 1, vv[p].first, vv[p].second, tmp);
				if (tmp < G[i][j])
					G[i][j] = tmp;
			}

			for (k = vv[0].second, p = 0; k > i; k--) {
				while (p + 1 < l && vv[p + 1].second >= k)
					p++;
				tmp = G[i][k - 1] + G[k][j] + l - (p + 1);
				//fprintf(stderr, "  b-split %d-%d: k=%d p+1=%d: tmp=%d\n", i, j, k, p+1, tmp);
				if (tmp < G[i][j])
					G[i][j] = tmp;
			}
		
			//if (l <= 3)
			//fprintf(stderr, "G(%d-%d)=%d\n", i, j, G[i][j]);
		}
}

void OptSplit() {
	for (l = 1; l <= N; l++)
		for (i = 1; i <= N - l + 1; i++) {
			j = i + l - 1;
			C[i][j] = INF;
			
			// Check to see if the current interval can form a set.
			v2.clear();
			for (k = i; k <= j; k++)
				v2.push_back(v[k]);
			sort(v2.begin(), v2.end());
			for (k = 0; k < l; k++)
				if (v2[k] != k + 1)
					break;
				
			if (k == l)
				C[i][j] = G[i][j];
			
			for (k = i; k < j; k++) {
				tmp = C[i][k] + C[k + 1][j];
				if (tmp < C[i][j])
					C[i][j] = tmp;
			}
		}
}

int main() {
	//freopen("x.txt", "r", stdin);

	scanf("%d", &N);
	for (i = 1; i <= N; i++)
		scanf("%d", &(v[i]));

	//N = 500;
	//for (i = 1; i <= N; i += 2)
	//	v[i] = (i / 2) + 1;
	//for (i = 2; i <= N; i += 2)
	//	v[i] = N - (i - 1) / 2;
	
	OptGroup();
	OptSplit();
	
	if (C[1][N] < 0)
		return 1;
	
	if (C[1][N] == INF)
		printf("impossible\n");
	else
		printf("%d\n", C[1][N]);
	return 0;
}
