#include <stdio.h>
#include <string.h>
#include <time.h>
#include <vector>

using namespace std;

#define NMAX 80111

vector<int> vec[NMAX], sons[NMAX];
int N;

void ReadInput() {
	int i, j, k;

	//freopen("x.txt", "r", stdin);
	scanf("%d", &N);
	for (k = 1; k < N; k++) {
		scanf("%d %d", &i, &j);
		vec[i].push_back(j);
		vec[j].push_back(i);
	}
}

char visited[NMAX];
int stk[NMAX], stkidx[NMAX], parent[NMAX], idxmin[NMAX], idxmax[NMAX], q[NMAX], level[NMAX], idx, niv;

void DFS() {
	int i, j;

	memset(visited, 0, sizeof(visited));
	visited[1] = 1;
	parent[1] = 1;

	stk[niv = 1] = 1;
	stkidx[1] = -1;
	idx = 1;
	idxmin[1] = 1;
	level[1] = 1;
	q[1] = 1;
	
	while (niv >= 1) {
		stkidx[niv]++;
		i = stk[niv];

		if (stkidx[niv] >= vec[i].size()) {
			idxmax[i] = idx;
			niv--;
		} else {
			j = vec[i][stkidx[niv]];
			if (!visited[j]) {
				visited[j] = 1;
				parent[j] = i;
				sons[i].push_back(j);
				level[j] = level[i] + 1;
				idx++;
				idxmin[j] = idx;
				q[idx] = j;
				niv++;
				stk[niv] = j;
				stkidx[niv] = -1;
			}
		}
	}
}

long long answer, t1, t2, t3;
long long dim[NMAX];

void Solve() {
	int i, j, k;

	answer = 0;
	for (idx = N; idx >= 1; idx--) {
		i = q[idx];
		
		dim[i] = 1; t3 = 0;
		for (k = 0; k < sons[i].size(); k++) {
			j = sons[i][k];
			dim[i] += dim[j];			
			t3 += (dim[j] * (dim[j] - 1)) / 2;
		}

		for (k = 0; k < sons[i].size(); k++) {
			j = sons[i][k];
			t1 = (dim[j] * (dim[j] - 1)) / 2;

			t2 = ((dim[i] - dim[j]) * (dim[i] - dim[j] - 1)) / 2;
			answer += t1 * (t2 - (t3 - t1)) * 2;
			answer += t1 * (t3 - t1);

			t2 = (dim[i] - dim[j]) * (long long) (N - dim[i]);
			answer += t1 * t2 * 2;
		}	
	}
}

int main() {
	ReadInput();
	DFS();
	Solve();
	printf("%I64d\n", answer);
	return 0;
}
