#include <stdio.h>
#include <string.h>
#include <time.h>

#define NMAX 1111
#define ZERO 510

int cnt[2][NMAX][NMAX], xmax, c, p, tstart;

void BruteForce(int N) {
	int i, j, newxmax, changed;
	
	memset(cnt, 0, sizeof(cnt));
	cnt[c = 0][ZERO][ZERO] = N;
	xmax = 0;
	
	changed = 1;
	while (changed) {
		changed = 0;
		newxmax = xmax;
		p = c;
		c = 1 - c;

		for (i = -xmax; i <= xmax; i++)
			for (j = -xmax; j <= xmax; j++)
				cnt[c][ZERO + i][ZERO + j] = cnt[p][ZERO + i][ZERO + j];
		
		for (i = -xmax; i <= xmax; i++)
			for (j = -xmax; j <= xmax; j++)
				if (cnt[p][ZERO + i][ZERO + j] >= 4) {
					cnt[c][ZERO + i + 1][ZERO + j]++;
					cnt[c][ZERO + i - 1][ZERO + j]++;
					cnt[c][ZERO + i][ZERO + j + 1]++;
					cnt[c][ZERO + i][ZERO + j - 1]++;
					cnt[c][ZERO + i][ZERO + j] -= 4;
					changed = 1;
					if (i == xmax || j == xmax)
						newxmax = xmax + 1;
				}

		xmax = newxmax;
	}

	fprintf(stderr, "N=%d xmax=%d : %.3lf sec\n", N, xmax, (double) (clock() - tstart) / CLOCKS_PER_SEC);
	/*
	for (i = -xmax; i <= xmax; i++) {
		for (j = -xmax; j <= xmax; j++)
			printf("%d ", cnt[c][ZERO + i][ZERO + j]);
		printf("\n");
	}
	*/
}

int main() {
	int N, t, x, y;

	scanf("%d %d", &N, &t);	
	tstart = clock();
	BruteForce(N);
	
	while (t--) {
		scanf("%d %d", &x, &y);
		if (x > xmax || x < -xmax || y > xmax || y < -xmax)
			printf("0\n");
		else
			printf("%d\n", cnt[c][ZERO + x][ZERO + y]);
	}
	
	return 0;
}
